function floodfillpath(x1, y1, z1, x2, y2, z2)


%Get tiff stack for mask and read to MaskImage
%[FileName,PathName,FilterIndex]=uigetfile('*.tiff');
%if FilterIndex==0
%    h=msgbox('Invalid File or Aborted Process','Error','error');
%else
%    FileTif=strcat(PathName,FileName);
%end
FileTif='C:\floodfillpath\theFile.tiff';
InfoImage=imfinfo(FileTif);
mImage=InfoImage(1).Width+2;
nImage=InfoImage(1).Height+2;
NumberImages=length(InfoImage)+2
MaskImage=zeros(nImage,mImage,NumberImages,'uint8');
 
TifLink = Tiff(FileTif, 'r');
for i=1:NumberImages
   if i==1 || i==NumberImages
       MaskImage(:,:,i)=0; %All values in the first and last layers of our 3D matrix should be zero
   else
       q=i-1; %Because of padding, i will always be one digit too high, so we fix that there
       TifLink.setDirectory(q); %Points Matlab at the correct 'page' in the tiff file
       tempImage=addborder(TifLink.read(),1,0,'outer'); %Adds border of black pixels to prevent edge effects
       MaskImage(:,:,i)=tempImage; %Saves the resulting image to our MaskImage matrix
   end
end
TifLink.close();  

% Set the start and end points
%str=input('Starting coordinate (x,y,z):','s');
%startpointmat=strsplit(str,',');
Sx=y1+1
Sy=x1+1;
Sz=z1+1;
%str=input('Ending coordinate (x,y,z:)','s');
%endpointmat=strsplit(str,',');
Ex=y2+1 %str2num(endpointmat{1,2})+1;
Ey=x2+1; %str2num(endpointmat{1,1})+1;
Ez=z2+1; %str2num(endpointmat{1,3})+1;

% Find index of start and end points from matrix
MaskSize=size(MaskImage);
StartIndex=sub2ind(MaskSize,Sx,Sy,Sz);
EndIndex=sub2ind(MaskSize,Ex,Ey,Ez);

% Initialize a matrix for our output
SolutionBinary=zeros(nImage,mImage,NumberImages);

% Propogate wave from start point through mask to end point
M=MaskSize(1);
N=MaskSize(1)*MaskSize(2);
neighbor_offsets=[-1, M, 1, -M, -N, N];
FinalPixel=0;
count=0;
currentpixels=StartIndex;
while FinalPixel==0 && count<(MaskSize(1)*MaskSize(2)*MaskSize(3)) %While we haven't found the end pixel and we're under our max number of loops
    count
	SolutionBinary(currentpixels)=count; %set the current pixels in the solution matrix to the current run count value
    count=count+1; %increment the counter
    currentpixels=bsxfun(@plus, currentpixels, neighbor_offsets); %get neighbors of current points
    currentpixels=currentpixels(:); %set the current pixel set to the neighbors
    %remove negative pixel index values
    negIndex=find(currentpixels(:)<0);
    currentpixels(negIndex)=[];
    %remove values greater than our matrix dimensions
    overIndex=find(currentpixels(:)>(MaskSize(1)*MaskSize(2)*MaskSize(3)));
    currentpixels(overIndex)=[];
    %remove non-zero pixels from active pixel list
    nonZeros=find(SolutionBinary(currentpixels)>0);
    currentpixels(nonZeros)=[];
    %remove duplicate entries
    currentpixels=unique(currentpixels);
    %remove pixels that are zero in the mask image (confines us to the
    %binary mask)
    zeroOrig=find(MaskImage(currentpixels)==0);
    currentpixels(zeroOrig)=[];
    %check to see if one of our new pixels is our end pixel
    EndFound=find(currentpixels==EndIndex);
    if ~isempty(EndFound)
        FinalPixel=1;
        SolutionBinary(EndIndex)=count;
    end
end

if ~isempty(EndFound)
    FinalLength=SolutionBinary(EndIndex);
    currentpixels=EndIndex
    for k=1:FinalLength
        SolutionBinary(currentpixels)=1; %set the current pixels in the solution matrix to 1 to create a binary image
        currentpixels=bsxfun(@plus, currentpixels, neighbor_offsets); %get neighbors of current points
        %check to see if one of our new pixels is our beginning pixel
        StartFound=find(currentpixels==StartIndex);
        if ~isempty(StartFound)
            SolutionBinary(StartIndex)=1;
            ZeroIt=find(SolutionBinary~=1);
            SolutionBinary(ZeroIt)=0;
            SolutionBinary=SolutionBinary(2:end-1,2:end-1,2:end-1);
            break;
        end
        currentpixels=currentpixels(:); %set the current pixel set to the neighbors
        %remove negative pixel index values
        negIndex=find(currentpixels(:)<0);
        currentpixels(negIndex)=[];
        %remove values greater than our matrix dimensions
        overIndex=find(currentpixels(:)>(MaskSize(1)*MaskSize(2)*MaskSize(3)));
        currentpixels(overIndex)=[];
        %remove duplicate entries
        currentpixels=unique(currentpixels);
        %remove pixels that are not the next point in the path
        pathdist=FinalLength-k;
        notPath=find(SolutionBinary(currentpixels)~=pathdist);
        currentpixels(notPath)=[];
        k=k+1;
    end

else
    noend=msgbox('Sorry, end not found!','Error','error');
end
    
%Export the result
%str=input('Export Tiff Filename (must end in .tiff):','s');
OutputFile='C:/floodfillpath/result.tiff';

l=1;
for l=1:(NumberImages-2)
    if l==1
        imwrite(SolutionBinary(:,:,l),OutputFile);
    else
		
        imwrite(SolutionBinary(:,:,l),OutputFile,'WriteMode','append');
    end
end
